// Kenny.cpp : Defines the entry point for the console application.
//
#include <stdlib.h>
#include <stdint.h>
#if defined(__GNUC__) && !defined(__MINGW32__)
//#include <sys/sysinfo.h>
#endif

#include "kennyInclude.h"

int CDECL main(int argc, char *argv[])
{
	int i;
	
	signal(SIGINT, SIG_IGN); 
	setbuf(stdout, NULL);
    setbuf(stdin, NULL);
    setvbuf(stdout, NULL, _IONBF, 0);
    setvbuf(stdin, NULL, _IONBF, 0);   

	// windows only:
#if defined(_WIN32) || defined(_WIN64)
	SYSTEM_INFO sysinfo;
#endif

	std::cout << KENNY_PROG_VERSION << std::endl;
	#ifdef KENNY_DEBUG_PERFT
		std::cout << "KENNY_DEBUG_PERFT defined" << std::endl;
	#endif
	#ifdef KENNY_DEBUG_MOVES
		std::cout << "KENNY_DEBUG_MOVES defined" << std::endl;
	#endif
	#ifdef KENNY_VERBOSE_EVAL
		std::cout << "KENNY_VERBOSE_EVAL defined" << std::endl;
	#endif
	#ifdef KENNY_DEBUG_EVAL
		std::cout << "KENNY_DEBUG_EVAL defined" << std::endl;
	#endif
	#ifdef KENNY_VERBOSE_SEE
		std::cout << "KENNY_VERBOSE_SEE defined" << std::endl;
	#endif
	#ifdef KENNY_DEBUG_WINBOARD
		std::cout << "KENNY_DEBUG_WINBOARD defined" << std::endl;
	#endif
	#ifdef KENNY_CUSTOM_VALUES
		std::cout << "KENNY_CUSTOM_VALUES defined" << std::endl;
	#endif
	#ifdef KENNY_CUSTOM_POSVALS
		std::cout << "KENNY_CUSTOM_VALUES defined" << std::endl;
	#endif
	#ifdef KENNY_CUSTOM_PSTABLES
		std::cout << "KENNY_CUSTOM_PSTABLES defined" << std::endl;
	#endif
	#ifdef KENNY_CUSTOM_ENDGAME
		std::cout << "KENNY_CUSTOM_ENDGAME defined" << std::endl;
	#endif

	dataInit();
	board.init();

	// windows only:
#if defined(_WIN32) || defined(_WIN64)
	GetSystemInfo(&sysinfo);
if (sysinfo.wProcessorArchitecture == PROCESSOR_ARCHITECTURE_INTEL)
		std::cout << "Version: X86, ";
if (sysinfo.wProcessorArchitecture == PROCESSOR_ARCHITECTURE_IA64)
		std::cout << "Version: IA64, ";
if (sysinfo.wProcessorArchitecture == PROCESSOR_ARCHITECTURE_AMD64)
		std::cout << "Version: X64, ";
	std::cout << sysinfo.dwNumberOfProcessors << " CPU's (1 CPU used)" << std::endl;
#else

#if UINTPTR_MAX == 0xffffffff
#define CPU_32
#elif UINTPTR_MAX == 0xffffffffffffffff
/* 64-bit */
#define CPU_64
#endif

//#if (CPU_32) 
//std::cout << "Version: Linux 32 BIT, ";
//#elif (CPU_64)
std::cout << "Version: Linux 64 BIT, ";

int processors;
processors = sysconf( _SC_NPROCESSORS_ONLN ); //get_nprocs();
std::cout << processors << " CPU's (1 CPU used)" << std::endl;

//#endif

#endif

	std::cout << "Search structure = " << sizeof(board)/1024 << "kB" << std::endl;

	// read the initialization file:
	strcpy(PATHNAME, argv[0]);
	strcpy(INIFILE, "KENNYx.ini");  // default name
	// check command-line to see if we need to use another ini-file:
	// usage: "KENNYx.exe i=somefile.ini"
	for (i = 1; i < argc; i++) 
	{
		if (!strncmp(argv[i], "i=", 2)) sscanf(argv[i]+2,"%s", INIFILE);
	}
	readIniFile();

	std::cout <<  "'help' displays a list of commands" << std::endl;
	commands();

	return 0;
}